Index: /trunk/include/sh_tiger.h
===================================================================
--- /trunk/include/sh_tiger.h	(revision 584)
+++ /trunk/include/sh_tiger.h	(revision 1)
@@ -7,11 +7,4 @@
 #include "samhain.h"
 
-typedef long int TigerType;
-
-#define TIGER_FILE -1
-#define TIGER_DATA -2
-
-/****************
-typedef long int TigerType;
 typedef enum {
   TIGER_FILE,
@@ -19,41 +12,30 @@
   TIGER_DATA
 } TigerType;
-*****************/
 
-#define TIGER_NOLIM ((UINT64)-1)
+extern SL_TICKET tiger_fd;
 
 /* the checksum function
  */
-char * sh_tiger_hash (const char * filename, TigerType what, 
-		      UINT64 Length, char * out, size_t len);
+/*@owned@*/ char * sh_tiger_hash (char * filename, TigerType what, 
+				  unsigned long Length);
 
 /* NEW Thu Oct 18 19:59:08 CEST 2001
  */
-int sh_tiger_hashtype (const char * c);
+int sh_tiger_hashtype (char * c);
 char * sh_tiger_generic_hash (char * filename, TigerType what, 
-			      UINT64 * Length, int timeout, 
-			      char * out, size_t len);
+			      unsigned long Length, int timeout);
 
 UINT32 * sh_tiger_hash_uint32 (char * filename, 
 			       TigerType what, 
-			       UINT64 Length, UINT32 * out, size_t len);
+			       unsigned long Length);
 
 /* get the type of hash function used
  * 0 = tiger192, 1 = sha1, 2 = md5
  */
-int sh_tiger_get_hashtype (void);
+int sh_tiger_get_hashtype ();
 
-/* set the hash fuction in use in the mask
+/* GnuPG-like format
  */
-void sh_tiger_get_mask_hashtype(unsigned long * mask);
-
-
-/* reset the hash function to the one in the mask
- */
-void sh_tiger_set_hashtype_mask(unsigned long mask);
-
-/* GnuPG-like format, returns allocated memory
- */
-/*@owned@*/ char * sh_tiger_hash_gpg (const char * filename, TigerType what, 
-				      UINT64 Length);
+/*@owned@*/ char * sh_tiger_hash_gpg (char * filename, TigerType what, 
+			  unsigned long Length);
 #endif
Index: /trunk/include/sh_tools.h
===================================================================
--- /trunk/include/sh_tools.h	(revision 584)
+++ /trunk/include/sh_tools.h	(revision 1)
@@ -8,27 +8,17 @@
  */
 #define SH_PROTO_SRP (1 << 0)
-#define SH_PROTO_IVA (1 << 1)
 #define SH_PROTO_MSG (1 << 2)
 #define SH_PROTO_BIG (1 << 3)
 #define SH_PROTO_END (1 << 4)
-#define SH_PROTO_EN1 (1 << 5)
+#define SH_PROTO_ENC (1 << 5)
 #define SH_PROTO_EN2 (1 << 6)
-#define SH_PROTO_ENC (SH_PROTO_EN1|SH_PROTO_EN2)
 #define SH_MASK_ENC (SH_PROTO_ENC|SH_PROTO_EN2)
 
 #ifdef SH_ENCRYPT
-/* returns pointer to errbuf
- */
-char * errorExplain (int err_num, char * errbuf, size_t len);
+char * errorExplain (int err_num);
 #endif
 
-/* Returns non-zero if interface exists
- */
-int sh_tools_iface_is_present(char *str);
-
-/* returns allocated buffer
- */
 char * sh_tools_safe_name(const char * str, int flag);
-
+int is_numeric (const char * address);
 int connect_port (char * address, int port, 
 		  char * ecall, int * errnum, char * errmsg, int errsiz);
@@ -36,8 +26,5 @@
 		    char * ecall, int * errnum, char * errmsg, int errsiz);
 void delete_cache(void);
-
-/* returns pointer to errbuf
- */
-char * sh_tools_errmessage (int tellme, char * errbuf, size_t len);
+char * sh_tools_errmessage (int tellme);
 
 
@@ -46,9 +33,7 @@
 #if defined (SH_WITH_SERVER)
 
-unsigned char sh_tools_probe_store(unsigned char protocol, int * probe_flag);
-
 int get_open_max (void);
 
-void put_header (/*@out@*/unsigned char * head, const int protocol, 
+void put_header (/*@out@*/unsigned char * head, int protocol, 
 		 unsigned long * length, char * u);
 
@@ -56,22 +41,11 @@
 int check_request_nerr (char * have, char * need);
 
-/* returns allocated buffer
- */
 char * hash_me (char * key, char * buf,   int buflen);
 int sh_tools_hash_vfy(char * key, char * buf, int buflen);
 
-/* returns allocated buffer
- */
-char * get_client_conf_file (const char * peer, unsigned long * length);
+char * get_client_conf_file (char * peer, unsigned long * length);
+char * get_client_data_file (char * peer, unsigned long * length);
 
-/* returns allocated buffer
- */
-char * get_client_data_file (const char * peer, unsigned long * length);
-
-/* returns allocated buffer
- */
-char * get_client_uuid_file (const char * peer, unsigned long * length, const char * uuid);
 #endif
-
 
 unsigned long read_port (int sockfd, char *buf, unsigned long nbytes, 
@@ -79,7 +53,5 @@
 
 
-#if defined (SH_WITH_CLIENT) || defined(SH_WITH_SERVER)
-
-void sh_tools_probe_reset();
+#if defined (SH_WITH_CLIENT)
 
 unsigned long write_port (int sockfd, char *buf, unsigned long nbytes, 
@@ -93,9 +65,8 @@
 		 unsigned long * length, char * u);
 
-/*
-  SL_TICKET open_tmp (void);
-  int close_tmp (SL_TICKET fd);
-  int rewind_tmp (SL_TICKET fd);
-*/
+
+SL_TICKET open_tmp (void);
+int close_tmp (SL_TICKET fd);
+int rewind_tmp (SL_TICKET fd);
 
 void sh_tools_server_cmd(const char * srvcmd);
@@ -107,9 +78,4 @@
 #endif
 
-#if defined(SH_WITH_CLIENT) || defined(SH_WITH_SERVER) || defined(SH_STEALTH) || defined(WITH_GPG) || defined(WITH_PGP)
-SL_TICKET open_tmp (void);
-int close_tmp (SL_TICKET fd);
-int rewind_tmp (SL_TICKET fd);
-#endif
 
 #endif
Index: /trunk/include/sh_trace.h
===================================================================
--- /trunk/include/sh_trace.h	(revision 584)
+++ /trunk/include/sh_trace.h	(revision 1)
@@ -5,23 +5,11 @@
 /* This file should be included via samhain.h only.
  */
-#ifdef SL_DEBUG
-#define SDG_0RETU _("return.\n")
-#define SDG_TERRO _("ERROR: file=<%s>, line=<%d>, reason=<%s>\n")
-#define SDG_AERRO _("ERROR: file=<%s>, line=<%d>, failed_assertion=<%s>\n")
-#define SDG_AFAIL _("FAILED: file=<%s>, line=<%d>, assertion=<%s>\n")
-#define SDG_ENTER _("enter=<%s>\n")
-#define SDG_RETUR _("return=<%s>.\n")
-#define SDG_ERROR _("error=<%ld>.\n")
-#endif
 
 #ifdef SL_DEBUG
 #define ASSERT(expr, expr1) \
       if (!(expr)) \
-	{ \
-         fprintf(stderr,	    \
+         fprintf(stderr, \
 		 SDG_AERRO, \
-		 FIL__, __LINE__, expr1 ); \
-          abort(); \
-	}
+		 FIL__, __LINE__, expr1 );
 
 
Index: /trunk/include/sh_unix.h
===================================================================
--- /trunk/include/sh_unix.h	(revision 584)
+++ /trunk/include/sh_unix.h	(revision 1)
@@ -23,10 +23,5 @@
 #define SH_UNIX_H
 
-/* For PATH_MAX */
 #include <limits.h>
-#if !defined(PATH_MAX)
-#define PATH_MAX 1024
-#endif
-
 #include <unistd.h>
 #include "samhain.h"
@@ -54,6 +49,4 @@
   SH_FILE_FIFO,
   SH_FILE_SOCKET,
-  SH_FILE_DOOR,
-  SH_FILE_PORT,
   SH_FILE_UNKNOWN
 } ShFileType;
@@ -68,5 +61,4 @@
 /* inode        */
 #define MODI_INO (1 << 2)
-
 /* user         */
 #define MODI_USR (1 << 3)
@@ -75,5 +67,4 @@
 /* mtime        */
 #define MODI_MTM (1 << 5)
-
 /* ctime        */
 #define MODI_CTM (1 << 6)
@@ -82,42 +73,10 @@
 /* size         */
 #define MODI_SIZ (1 << 8)
-
 /* file mode    */
 #define MODI_MOD (1 << 9)
 /* hardlinks    */
 #define MODI_HLN (1 << 10)
-/* device type   */
+/* device num   */
 #define MODI_RDEV (1 << 11)
-
-/* size may grow   */
-#define MODI_SGROW (1 << 12)
-/* use prelink     */
-#define MODI_PREL (1 << 13)
-/* get content     */
-#define MODI_TXT ((1 << 14)|MODI_CHK)
-#define MODI_TXT_ENABLED(a) (((a)&(1 << 14))!=0)
-
-/* get audit record  */
-#define MODI_AUDIT (1 << 15)
-#define MODI_AUDIT_ENABLED(a) (((a)&(1 << 15))!=0)
-/* do not check  */
-#define MODI_NOCHECK (1 << 16)
-/* do not check  */
-#define MODI_ALLIGNORE (1 << 17)
-
-#define MODI_TIGER192  0x01000000UL
-#define MODI_SHA1      0x02000000UL
-#define MODI_MD5       0x03000000UL
-#define MODI_SHA256    0x04000000UL
-#define MODI_HASHTYPE  0x0F000000UL
-
-#define MODI_INIT 0xD0000000UL
-#define MODI_INITIALIZED(a) (((a) & 0xF0000000UL) == MODI_INIT)
-
-#define MODI_SET(a, b) ((a) |= (b))
-#define MODI_CLEAR(a, b) ((a) &= ~(b))
-#define MODI_ISSET(a, b) (((a) & (b)) != 0)
-
-#define SH_TXT_MAX 9200
 
 #define MASK_ALLIGNORE_  0
@@ -127,5 +86,5 @@
 #define MASK_LOGFILES_   (MASK_ATTRIBUTES_|MODI_HLN|MODI_LNK|MODI_INO)
 extern  unsigned long mask_LOGFILES;
-#define MASK_LOGGROW_    (MASK_LOGFILES_|MODI_SIZ|MODI_SGROW|MODI_CHK) 
+#define MASK_LOGGROW_    (MASK_LOGFILES_|MODI_SIZ) 
 extern  unsigned long mask_LOGGROW;
 #define MASK_READONLY_   (MASK_LOGFILES_|MODI_CHK|MODI_SIZ|MODI_MTM|MODI_CTM)
@@ -136,15 +95,12 @@
 extern  unsigned long mask_USER0;
 extern  unsigned long mask_USER1;
-extern  unsigned long mask_USER2;
-extern  unsigned long mask_USER3;
-extern  unsigned long mask_USER4;
-/* like READONLY, but without MTM,CTM,SIZ,INO, and with PREL)
- */
-#define MASK_PRELINK_   (MASK_ATTRIBUTES_|MODI_HLN|MODI_LNK|MODI_CHK|MODI_PREL)
+/* like READONLY, but without MTM,CTM,SIZ,INO)
+ */
+#define MASK_PRELINK_   (MASK_ATTRIBUTES_|MODI_HLN|MODI_LNK|MODI_CHK)
 extern  unsigned long mask_PRELINK;
 
 typedef struct file_struct {
-  unsigned long    check_flags;
-  int              file_reported;
+  unsigned long    check_mask;
+  int              reported;
   char             fullpath[PATH_MAX];
   ShFileType       type;
@@ -153,9 +109,9 @@
   mode_t           mode;
   nlink_t          hardlinks;
-#if defined(__linux__) || defined(HAVE_STAT_FLAGS)
+#if defined(__linux__)
   unsigned long    attributes;
-  char             c_attributes[ATTRBUF_SIZE];
-#endif
-  char             c_mode[CMODE_SIZE];
+  char             c_attributes[16];
+#endif
+  char             c_mode[11];
   uid_t            owner;
   char             c_owner[USER_MAX+2];
@@ -170,59 +126,28 @@
   time_t           ctime;
 
-  char           * link_path;
+  char             linkpath[PATH_MAX];
   mode_t           linkmode;
   char             link_c_mode[11];
   int              linkisok;
-  char           * attr_string;
 } file_type;
 
-extern int sh_unix_check_selinux;
-extern int sh_unix_check_acl;
-
-/* destroy userid cache 
- */
-void sh_userid_destroy ();
-
-/* --- run a command, securely --- 
- */
-int sh_unix_run_command (const char * str);
-
-/* Ignore SIGPIPE
- */
-void sh_unix_ign_sigpipe();
-
 /* mlock utilities
  */
-int sh_unix_mlock(const char * file, int line, void * addr, size_t len);
+int sh_unix_mlock(void * addr, size_t len);
 int sh_unix_munlock(void * addr, size_t len);
-int sh_unix_count_mlock(void);
-/* public for unit tests */
-int sh_unix_pagesize(void);
-unsigned long sh_unix_lookup_page(void * in_addr, size_t len, int * num_pages);
+int sh_unix_count_mlock();
 
 /* chroot directory
  */
-int sh_unix_set_chroot(const char * str);
+int sh_unix_set_chroot(char * str);
 
 /* whether to use localtime for file timesatams in logs
  */
-int sh_unix_uselocaltime (const char * c);
-
-/* whether to perform selinux/acl checks
- */ 
-#ifdef USE_XATTR
-int sh_unix_setcheckselinux (const char * c);
-#endif
-#ifdef USE_ACL
-int sh_unix_setcheckacl (const char * c);
-#endif
-#if defined(__linux__) || defined(HAVE_STAT_FLAGS)
-int sh_unix_setcheckattributes (const char * c);
-#endif
+int sh_unix_uselocaltime (char * c);
 
 /* set I/O limit
  */
-int  sh_unix_set_io_limit (const char * c);
-void sh_unix_io_pause (void);
+int  sh_unix_set_io_limit (char * c);
+void sh_unix_io_pause ();
 
 /* get file type
@@ -232,9 +157,9 @@
 /* reset masks for policies
  */
-int sh_unix_maskreset(void);
+int sh_unix_maskreset();
 
 /* return true if database is remote
  */
-int file_is_remote (void);
+int file_is_remote ();
 
 /* return the path to the configuration/database file
@@ -248,9 +173,6 @@
 /* close all files >= fd, except possibly one
  */
-void sh_unix_closeall (int fd, int except, int inchild);
-
-/* Check whether directory for pid file exists
- */
-int sh_unix_check_piddir (char * pidpath);
+void sh_unix_closeall (int fd, int except);
+
 
 /* write lock for filename
@@ -264,14 +186,14 @@
 /* write the PID file
  */
-int sh_unix_write_pid_file(void);
+int sh_unix_write_pid_file();
 
 /* rm the PID file
  */
-int sh_unix_rm_pid_file(void);
+int sh_unix_rm_pid_file();
 
 
 /* checksum of own binary
  */
-int sh_unix_self_hash (const char * c);
+int sh_unix_self_hash (char * c);
 
 /* return BAD on failure
@@ -281,9 +203,9 @@
 /* add a trusted user to the list 
  */
-int tf_add_trusted_user(const char *);
+int tf_add_trusted_user(char *);
 
 /* check a file 
  */
-int tf_trust_check (const char * file, int mode);
+int tf_trust_check (char * file, int mode);
 
 /* initialize group vector
@@ -298,5 +220,5 @@
 /* set the timeserver address
  */
-int sh_unix_settimeserver (const char * address);
+int sh_unix_settimeserver (char * address);
 void reset_count_dev_time(void);
 
@@ -307,14 +229,14 @@
 /* deamon mode 
  */
-int sh_unix_setdeamon  (const char * dummy);
-int sh_unix_setnodeamon(const char * dummy);
+int sh_unix_setdeamon  (char * dummy);
+int sh_unix_setnodeamon(char * dummy);
 
 /* Test whether file exists
  */
-int sh_unix_file_exists(char * path);
+int sh_unix_file_stat(char * path);
 
 /* test whether file exists with proper attributes
  */
-int sh_unix_device_readable(int fd);
+int sh_unix_file_exists(int fd);
 
 /* local host
@@ -331,12 +253,7 @@
 /* int sh_unix_is_secure_dir (ShErrLevel level, char * tmp); */
 
-/* check whether there's a rotated log with the correct inode and checksum 
- */
-int sh_check_rotated_log (const char * path,  
-			  UINT64 old_size, UINT64 old_inode, const char * old_hash, unsigned long mask);
-
 /* obtain file info
  */
-int sh_unix_getinfo (int level, const char * filename, file_type * theFile, 
+int sh_unix_getinfo (int level, char * filename, file_type * theFile, 
 		     char * fileHash, int flagrel);
 
@@ -349,11 +266,11 @@
 int  sh_unix_init(int goDaemon);
 
-/* for local time use thetime = 0, returns pointer to buffer 
- */
-char * sh_unix_time (time_t thetime, char * buffer, size_t len);
-
-/* convert to GMT time, returns pointer to buffer
- */
-char * sh_unix_gmttime (time_t thetime, char * buffer, size_t len);
+/* for local time use thetime = 0 
+ */
+/*@owned@*/ char * sh_unix_time (time_t thetime);
+
+/* convert to GMT time
+ */
+char * sh_unix_gmttime (time_t thetime);
 
 /* effective user info
@@ -361,11 +278,8 @@
 int  sh_unix_getUser (void);
 
-/* get home directory, , returns pointer to out
- */
-char *  sh_unix_getUIDdir (int level, uid_t uid, char * out, size_t len);
-
-/* get a group GID 
- */
-long sh_group_to_gid (const char * g, int * fail);
+/* get home directory
+ */
+char *  sh_unix_getUIDdir (int level, uid_t uid);
+
 
 #ifdef HAVE_GETTIMEOFDAY
@@ -389,22 +303,19 @@
 
 void   sh_sigtrap_handler (int signum);
+extern volatile int sh_not_traced;
 
 #ifdef HAVE_GETTIMEOFDAY
+#if TIME_WITH_SYS_TIME
+#include <sys/time.h>
+#include <time.h>
+#else
 #if HAVE_SYS_TIME_H
 #include <sys/time.h>
-#endif
+#else
 #include <time.h>
 #endif
-
-struct sh_sigtrap_variables {
-  int not_traced;
-#ifdef HAVE_GETTIMEOFDAY
-  struct timeval save_tv;
-#endif
-};
-
-struct sh_sigtrap_variables * sh_sigtrap_variables_get();
-
-int sh_sigtrap_max_duration_set (const char * str);
+#endif
+extern struct timeval  save_tv;
+#endif
 
 static inline
@@ -425,26 +336,19 @@
 int sh_derr(void)
 {
-  struct sh_sigtrap_variables * sigtrap_variables;
-  sigtrap_variables = sh_sigtrap_variables_get();
-  if (sigtrap_variables == NULL) {
-    /* Perhaps, its better to not die, and to continue using Samhain,
-       even if this part does not work. */
-    return (0);
-  }
-
-  sigtrap_variables->not_traced = 0;
+  sh_not_traced = 0;
 
 #ifdef HAVE_GETTIMEOFDAY
-  gettimeofday(&sigtrap_variables->save_tv, NULL);
-#endif
-
-  /* raise() sends to same thread, like pthread_kill(pthread_self(), sig); 
-   */
+  gettimeofday(&save_tv, NULL);
+#endif
+
+#if defined(__linux__) && defined(__GNUC__) && defined(__i386__)
+  __asm__ __volatile__ ("int $0x03");
+#else
   raise(SIGTRAP);
+#endif
   
-  if (sigtrap_variables->not_traced == 0)
+  if (sh_not_traced == 0)
     _exit(5);
-
-  sigtrap_variables->not_traced = 0;
+  sh_not_traced = 0;
   return (0);
 }
Index: /trunk/include/sh_userfiles.h
===================================================================
--- /trunk/include/sh_userfiles.h	(revision 584)
+++ /trunk/include/sh_userfiles.h	(revision 1)
@@ -9,5 +9,5 @@
 
 #ifdef SH_USE_USERFILES
-int sh_userfiles_init  (struct mod_type * arg);
+int sh_userfiles_init  (void);
 int sh_userfiles_timer (time_t tcurrent);
 int sh_userfiles_check (void);
@@ -16,9 +16,9 @@
 int sh_userfiles_reconf (void);
 
-int sh_userfiles_set_uid (const char * str);
-int sh_userfiles_add_file(const char *c);
-int sh_userfiles_set_interval(const char *c);
-int sh_userfiles_set_active(const char *c);
-int sh_userfiles_check_internal(void);
+int sh_userfiles_set_uid (char * str);
+int sh_userfiles_add_file(char *c);
+int sh_userfiles_set_interval(char *c);
+int sh_userfiles_set_active(char *c);
+int sh_userfiles_check_internal();
 
 extern sh_rconf sh_userfiles_table[];
Index: /trunk/include/sh_utils.h
===================================================================
--- /trunk/include/sh_utils.h	(revision 584)
+++ /trunk/include/sh_utils.h	(revision 1)
@@ -40,9 +40,7 @@
   unsigned long   data_ulong;
   long            data_long;
-  char           *data_str;
+  /*@null@*/char *data_str;
 } st_format;
 
-/* returns allocated string
- */
 char * sh_util_formatted (const char * fmt, st_format * ftab);
 
@@ -58,81 +56,52 @@
  *  generator. 
  */
-UINT32 taus_get            (void);  
+UINT32 taus_get            (void *state1, void *state2, void *state3);  
 double taus_get_double     (void *vstate);  /* fast */
 int    taus_seed           (void);
 
-/* returns allocated memory
- */
-char * sh_util_strdup (const char * str) SH_GNUC_MALLOC;
-char * sh_util_strdup_track (const char * str, 
-			     char * file, int line) SH_GNUC_MALLOC;
-
-/* returns allocated memory
- */
-char * sh_util_strdup_l (const char * str, size_t len) SH_GNUC_MALLOC;
-
-/* returns pointer within str
- */
+char * sh_util_strdup (const char * str);
 char * sh_util_strsep (char **str, const char *delim);
-
-/* compactify verbose acl text, returns allocated memory
- */
-char * sh_util_acl_compact (char * buf, ssize_t len);
 
 /* set signature type HASH-TIGER/HMAC-TIGER
  */
-int sh_util_sigtype (const char * c);
+int sh_util_sigtype (char * c);
 
 /* compute a signature
  */
 char * sh_util_siggen (char * hexkey,  
-		       char * text, size_t textlen, 
-		       char * sigbuf, size_t sigbuflen);
+		       char * text, size_t textlen);
 
 /* eval boolean input
  */
-int sh_util_flagval(const char * c, int * fval);
+int sh_util_flagval(char * c, int * fval);
 
 /* ask if a file should be updated (returns S_TRUE/S_FALSE)
  */
-int sh_util_ask_update(const char * path);
-int sh_util_set_interactive(const char * str);
-int sh_util_update_file (const char * str);
+int sh_util_ask_update(char * path);
+int sh_util_set_interactive(char * str);
 
 /* don't log output files
  */
-int sh_util_hidesetup(const char * c);
-
-/* valif utf-8 string
- */
-int sh_util_valid_utf8 (const unsigned char * str);
-
-/* filenames are utf8
- */
-int sh_util_obscure_utf8 (const char * c);
+int sh_util_hidesetup(char * c);
 
 /* exceptions to obscure name check
  */
-int sh_util_obscure_ok (const char * str);
+int sh_util_obscure_ok (char * str);
 
-/* output a hexchar[2]; i2h must be char[2]
+/* read a hexchar
  */
-char * sh_util_charhex( unsigned char c, char * i2h );
-
-/* read a hexchar, return int value (0-15)
- */
-int sh_util_hexchar( char c ) SH_GNUC_CONST;
+int sh_util_hexchar( char c );
 
 /* change verifier 
  */
-int sh_util_set_newkey (const char * str);
+int sh_util_set_newkey (char * str);
 
 /* server mode 
  */
-int sh_util_setserver (const char * dummy);
+int sh_util_setserver (char * dummy);
 
 /* a simple compressor
  */
-size_t sh_util_compress (char * dest, char * src, size_t dest_size);
+long sh_util_compress (char * dest, char * src, size_t dest_size);
 
 /* an even simpler en-/decoder 
@@ -147,9 +116,9 @@
 /* set timer for main loop
  */
-int sh_util_setlooptime (const char * str);
+int sh_util_setlooptime (char * str);
 
 /* whether init or check the database
  */
-int  sh_util_setchecksum (const char * str);
+int  sh_util_setchecksum (char * str);
 
 /* compare an in_string against a regular expression regex_str
@@ -160,11 +129,11 @@
 
 /* returns freshly allocated memory, return value should be free'd.
- * Argument list must be NULL terminated.
+ * Arhument list must be NULL terminated.
  */
-char * sh_util_strconcat (const char * arg1, ...) SH_GNUC_MALLOC SH_GNUC_SENTINEL;
+char * sh_util_strconcat (const char * arg1, ...);
 
 /* check if string is numeric only
  */
-int sh_util_isnum (const char *str) SH_GNUC_PURE;
+int sh_util_isnum (char *str);
 
 /* init a key w/random string
@@ -175,11 +144,9 @@
 /* returns freshly allocated memory, return value should be free'd
  */
-char * sh_util_dirname(const char * fullpath);
+char * sh_util_filename(char * fullpath);
 
 /* returns freshly allocated memory, return value should be free'd
  */
-char * sh_util_safe_name (const char * name) SH_GNUC_MALLOC;
-
-char * sh_util_safe_name_keepspace (const char * name) SH_GNUC_MALLOC;
+char * sh_util_safe_name (const char * name);
 
 /* check max size of printf result string
@@ -189,30 +156,9 @@
 /* check for obscure filenames
  */
-int sh_util_obscurename (ShErrLevel level, const char * name, int flag);
+int sh_util_obscurename (ShErrLevel level, char * name, int flag);
 
 /* returns freshly allocated memory, return value should be free'd
  */
-char * sh_util_basename(const char * fullpath);
-
-/* required size (including terminating NULL) for string of strlen l
- */
-#define SH_B64_SIZ(l)  (1 + ((((l) + 2) / 3) * 4))
-
-/* return len of encoded string
- */
-size_t sh_util_base64_enc (unsigned char * out, const unsigned char * instr, 
-			   size_t lin);
-
-/* return allocated encoded string in out, return its len
- */
-size_t sh_util_base64_enc_alloc (char **out, const char *in, size_t inlen);
-
-/* return len of decoded string
- */  
-size_t sh_util_base64_dec (unsigned char *out, const unsigned char *in, size_t lin);
-
-/* return allocated decoded string in out, return its len
- */  
-size_t sh_util_base64_dec_alloc (unsigned char **out, const unsigned char *in, size_t lin);
+char * sh_util_basename(char * fullpath);
 
 #endif
Index: /trunk/include/sh_utmp.h
===================================================================
--- /trunk/include/sh_utmp.h	(revision 584)
+++ /trunk/include/sh_utmp.h	(revision 1)
@@ -6,35 +6,17 @@
 
 #ifdef SH_USE_UTMP
-int sh_utmp_init   (struct mod_type * arg);
-int sh_utmp_timer  (time_t tcurrent);
-int sh_utmp_check  (void);
-int sh_utmp_end    (void);
-int sh_utmp_reconf (void);
+int sh_utmp_init  (void);
+int sh_utmp_timer (time_t tcurrent);
+int sh_utmp_check (void);
+int sh_utmp_end (void);
+int sh_utmp_null (void);
 
-int sh_utmp_set_login_activate (const char * c);
-int sh_utmp_set_login_solo     (const char * c);
-int sh_utmp_set_login_multi    (const char * c);
-int sh_utmp_set_logout_good    (const char * c);
-int sh_utmp_set_login_timer    (const char * c);
+int sh_utmp_set_login_activate (char * c);
+int sh_utmp_set_login_solo     (char * c);
+int sh_utmp_set_login_multi    (char * c);
+int sh_utmp_set_logout_good    (char * c);
+int sh_utmp_set_login_timer    (char * c);
 
 extern sh_rconf sh_utmp_table[];
-
-/* >>           Login tracking             << */
-
-/* 'yes', 'no', 'paranoid'                    */
-int sh_login_set_siglevel      (const char * c);
-
-/* 'yes', 'no', 'domain'                      */
-int sh_login_set_checklevel    (const char * c);
-
-/* 'always' 'never' workdays(..) sunday(..)   */
-int sh_login_set_def_allow     (const char * c);
-
-/* user:'always' 'never' workdays(..)         */
-int sh_login_set_user_allow    (const char * c);
-
-/* Reset everything to defaults.              */
-void sh_login_reset (void);
-
 #endif
 
